/*
 * ===========================================================================
 *
 * $Id: plugin_DoD.sma,v 1.0 2005/10/24 00:45:45 Sir Drink a lot Exp $
 *
 *
 * Copyright (c) 1999-2004 Alfred Reynolds, Florian Zschocke, Magua
 *
 *   This file is part of Admin Mod.
 *
 *   Admin Mod is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   Admin Mod is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Admin Mod; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 * ===========================================================================
 *
 * Comments:
 *
 * Thx. to {BB}, [VHL]Tyr, {MRC}Krycek and SR71Goku for their first DoD plugins
 *
 *
*/

#include <string>
#include <admin>
#include <adminlib>
 
new AM_VERSION_STRING[] = "2.50.60.rc1";
 
#define ACCESS_CHANGE_TEAM 128
#define ACCESS_CVAR 512
#define ACCESS_RESTRICT 32
 
#define MAX_CVARS 46
#define MAX_RESTRICT 30

new g_CVar[MAX_CVARS][]={
	"mp_limitallieslight",
	"mp_limitalliesheavy",
	"mp_limitalliesassault",
	"mp_limitalliessniper",
	"mp_limitalliesmg",
	"mp_limitalliesgarand",
	"mp_limitalliescarbine",
	"mp_limitalliesthompson",
	"mp_limitalliesgreasegun",
	"mp_limitalliesspring",
	"mp_limitalliesbar",
	"mp_limitallies30cal",
	"mp_limitaxislight",
	"mp_limitaxisheavy",
	"mp_limitaxisassault",
	"mp_limitaxisniper",
	"mp_limitaxismg",
	"mp_limitaxiskar",
	"mp_limitaxisk43",
	"mp_limitaxisscopedkar",
	"mp_limitaxismp40",
	"mp_limitaxismp44",
	"mp_limitaxisfg42",
	"mp_limitaxismg34",
	"mp_limitaxismg42",
	"mp_limitbritlight",
	"mp_limitbritmg",
	"mp_limitbritmortar",
	"mp_limitbritpiat",
	"mp_limitbritsniper",
	"mp_allowspectators",
	"mp_bulletwhizz",
	"mp_chatmsg",
	"mp_clan_match",
	"mp_clan_restartround",
	"mp_clan_timer",
	"mp_deathmsg",
	"mp_fadetoblack",
	"mp_flashlight",
	"mp_footsteps",
	"mp_forcecamera",
	"mp_forcechasecam",
	"mp_respawntime",
	"mp_tkpenalty",
	"mp_teamlimit",
	"mp_voice"
};

new g_Command[MAX_CVARS][]={
	"admin_allieslight",
	"admin_alliesheavy",
	"admin_alliesassault",
	"admin_alliessniper",
	"admin_alliesmg",
	"admin_alliesgarand",
	"admin_alliescarbine",
	"admin_alliesthompson",
	"admin_alliesgreasegun",
	"admin_alliesspring",
	"admin_alliesbar",
	"admin_allies30cal",
	"admin_axislight",
	"admin_axisheavy",
	"admin_axisassault",
	"admin_axissniper",
	"admin_axismg",
	"admin_axiskar",
	"admin_axisk43",
	"admin_axisscopedkar",
	"admin_axismp40",
	"admin_axismp44",
	"admin_axisfg42",
	"admin_axismg34",
	"admin_axismg42",
	"admin_britlight",
	"admin_britmg",
	"admin_britmortar",
	"admin_britpiat",
	"admin_britsniper",
	"admin_allowspectate",
	"admin_bulletwhizz",
	"admin_chatmsg",
	"admin_clan_match",
	"admin_clan_restart",
	"admin_clan_timer",
	"admin_deathmsg",
	"admin_fadetoblack",
	"admin_flashlight",
	"admin_footsteps",
	"admin_forcecamera",
	"admin_forcechasecam",
	"admin_respawntime",
	"admin_tkpenalty",
	"admin_teamlimit",
	"admin_voice"
};
	
new g_Description[MAX_CVARS][] = {
	"admin_allieslight <-1|0|>0>: DoD 1.0 only! - Specifies the maximum # of Riflemen the Allies can have.",
	"admin_alliesheavy <-1|0|>0>: DoD 1.0 only! - Specifies the maximum # of Support Infantry the Allies can have.",
	"admin_alliesassault <-1|0|>0>: DoD 1.0 only! - Specifies the maximum # of Sargeants the Allies can have.",
	"admin_alliessniper <-1|0|>0>: DoD 1.0 only! - Specifies the maximum # of Snipers the Allies can have.",
	"admin_alliesmg <-1|0|>0>: DoD 1.0 only! - Specifies the maximum # of Machine Gunners the Allies can have.",
	"admin_alliesgarand <-1|0|>0>: Limits the M1 Garand. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_alliescarbine <-1|0|>0>: Limits the M1 Carbine. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_alliesthompson <-1|0|>0>: Limits the M1A1 Thompson. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_alliesgreasegun <-1|0|>0>: Limits the M3 GreaseGun. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_alliesspring <-1|0|>0>: Limits the 19O3A4 Sniper. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_alliesbar <-1|0|>0>: Limits the BAR. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_allies30cal <-1|0|>0>: Limits the .30cal MG. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_axislight <-1|0|>0>: DoD 1.0 only! - Specifies the maximum # of Grenadiers the Axis can have.",
	"admin_axisheavy <-1|0|>0>: DoD 1.0 only! - Specifies the maximum # of Scharfhrers the Axis can have.",
	"admin_axisassault <-1|0|>0>: DoD 1.0 only! - Specifies the maximum # of Unteroffiziers the Axis can have.",
	"admin_axissniper <-1|0|>0>: DoD 1.0 only! - Specifies the maximum # of Scharfschuetzes the Axis can have.",
	"admin_axismg <-1|0|>0>: DoD 1.0 only! - Specifies the maximum # of MG-Schtzes the Axis can have.",
	"admin_axiskar <-1|0|>0>:  Limits the Karabiner 98. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_axisk43 <-1|0|>0>:  Limits the Karabiner 43. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_axisscopedkar <-1|0|>0>: Limits the K98 High Turret. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_axismp40 <-1|0|>0>: Limits the Mp40. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_axismp44 <-1|0|>0>: Limits the Sturmgewehr 44. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_axisfg42 <-1|0|>0>: Limits the Fg42. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_axismg34 <-1|0|>0>: Limits the Mg34. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_axismg42 <-1|0|>0>: Limits the Mg42. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_britlight <-1|0|>0>: Limits the Enfield. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_britmg <-1|0|>0>: Limits the Bren. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_britmortar <-1|0|>0>: Limits the Sten. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_britpiat <-1|0|>0>: Limits the PIAT. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_britsniper <-1|0|>0>: Limits the Scoped Enfield. -1=class unrestricted,0=class disabled,>0=class restricted to number.",
	"admin_allowspectate <0|1>: Determines if the server will allow clients to spectate the game.",
	"admin_bulletwhizz <0|1>: Toggles the bulletwhizz sound to on or off.",
	"admin_chatmsg <1|2>: Toggle standard HL chat messages, 1=Yes, 2=No.",
	"admin_clan_match <0|1>: Toggles clan match mode.",
	"admin_clan_restart <1>: Restarts the clan match but waits for the amount of time set in admin_clan_timer.",
	"admin_clan_timer <seconds>: Sets the amount of time to wait before restarting when the admin_clan_restart command is used.",
	"admin_deathmsg <0|1>: Kill icons/messages in top right corner of screen.",
	"admin_fadetoblack <0|1>: mp_fadetoblack off or on",
	"admin_flashlight <0|1>: mp_flashlight off or on",
	"admin_footsteps <0|1>: mp_footsteps off or on",
	"admin_forcecamera <#>: setting for mp_forcecamera",
	"admin_forcechasecam <#>: setting for mp_forcechasecam",
	"admin_respawntime <data>: Old DoD Version - The time it takes for a player to respawn after beign killed",
	"admin_tkpenalty <number>: Number of TK's before kick, -1 to turn off.",
	"admin_teamlimit <number>: Number of extra players a team will be allowed to have.",
	"admin_voice <0|1>: HL voice system, 1=Team can talk across map, 2=Can only talk within a range."
};


public plugin_init(){
	plugin_registerinfo("AdminMod DoD Plugin","Team change / Restart Round / Class Restrictions / Cvar Management",AM_VERSION_STRING);
	new i;
	for(i=0;i<=MAX_CVARS;i++){
		if(i<=MAX_RESTRICT){
			plugin_registercmd(g_Command[i],"set_cvar",ACCESS_RESTRICT,g_Description[i]);
		}else{
			plugin_registercmd(g_Command[i],"set_cvar",ACCESS_CVAR,g_Description[i]);
		}
	}
	plugin_registercmd("admin_ally","admin_changeteam",ACCESS_CHANGE_TEAM,"admin_ally <player>: Changes target to ALLIE team.");
	plugin_registercmd("admin_axis","admin_changeteam",ACCESS_CHANGE_TEAM,"admin_axis <player>: Changes target to AXIS team.");
	return PLUGIN_CONTINUE;
}

public admin_changeteam(HLCommand,HLData,HLUserName,UserIndex) {
    new Command[MAX_COMMAND_LENGTH];
    new Data[MAX_DATA_LENGTH];
    new TargetName[MAX_NAME_LENGTH];
    new Text[MAX_TEXT_LENGTH];
    new User[MAX_NAME_LENGTH];
    convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
    strstripquotes(Data);
    if(!getvar("allow_client_exec")) {
        selfmessage("You cannot use this command because allow_client_exec is 0.");
    } else if(!check_user(Data)) {
        selfmessage("Unrecognized player: ");
        selfmessage(Data);
    } else {
        get_username(Data,TargetName,MAX_NAME_LENGTH);
        if(check_immunity(TargetName) != 0) {
            snprintf(Text, MAX_TEXT_LENGTH, "Laf. You can't move %s onto another team, you silly bear.", TargetName);
            messageex(User,Text,print_chat);
        } else {
            say_command(User,Command,TargetName);
            if(!strcmp(Command,"admin_axis")) {
                execclient(TargetName, "jointeam 2");
            } else {
                execclient(TargetName, "jointeam 1");
            }
        }
    }
    return PLUGIN_HANDLED;
}

public set_cvar(HLCommand,HLData,HLUserName,UserIndex) {
	new Text[MAX_TEXT_LENGTH];
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new i;
	convert_string_all(HLCommand,HLData,HLUserName,Command,Data,User);
	for(i=0;i<=MAX_CVARS;i++){
		if(strcmp(Command,g_Command[i])==0){
			if(Data[0] != 0 && i<=MAX_RESTRICT && access(ACCESS_RESTRICT)){
				execute_command(User,Command,g_CVar[i],Data);
			}else if(Data[0] != 0 && i>MAX_RESTRICT && access(ACCESS_CVAR)){
				execute_command(User,Command,g_CVar[i],Data);
			}else{
				getstrvar(g_CVar[i],Data,MAX_DATA_LENGTH);
				snprintf(Text,MAX_TEXT_LENGTH,"%s is currently set to %s",g_CVar[i],Data);
				selfmessage(Text);
			}
			break;
		}
	}
	return PLUGIN_HANDLED;
}	